<?php

/**
 * A handler to provide graphic displays for booleans.
 *
 * Based on: views_handler_field_boolean
 * 
 * @ingroup views_field_handlers
 */
class boolean_icon_handler_field_boolean_graphic extends views_handler_field {
  function option_definition() {
    $options = parent::option_definition();
    $options['not'] = array('definition bool' => 'reverse');

    return $options;
  }

  function options_form(&$form, &$form_state) {
    $form['not'] = array(
      '#type' => 'checkbox',
      '#title' => t('Reverse'),
      '#description' => t('If checked, true will be displayed as false.'),
      '#default_value' => $this->options['not'],
    );
    parent::options_form($form, $form_state);
  }

  function render($values) {
    $value = $this->get_value($values);
    if (!empty($this->options['not'])) {
      $value = !$value;
    }

    $icon = $value ?
          variable_get('boolean_icon_true_ico', drupal_get_path('module', 'boolean_icon') . '/yes.png') : 
          variable_get('boolean_icon_false_ico', drupal_get_path('module', 'boolean_icon') . '/no.png');
    $title = $value ? t('True') : t('False');
            
    // Return element.
    return array(
      '#theme' => 'image',
      '#path' => $icon,
      '#title' => $title,
    );
  }
}
